class Node{
	int key;
	Node left;
	Node right;
	Node p;
}

class Tree{
	Node root;
}

public class Main {

	public static void main(String[] args) {
		testAltezzaMedia(1000000, 10000000, 30);

	}
	
	
	static void testAltezzaMedia (int nMax, 
			              int vMax, int trials) {
		
		for (int n=2; n<=nMax; n*=2) {
			long sommaH=0;
			for (int i=0; i<trials; i++) {
				Tree t = creaTree(n, vMax);
				sommaH+= height(t);
			}
			double media = (double) sommaH /trials;
			System.out.println ("n="+n + " h media="+media);
		}
		
	}
	
	/*
	 * metodo che crea in modo randomico un albero con n 
	 * nodi, in cui ogni chiave varia tra 0 e max-1
	 */
	static Tree creaTree (int n, int max) {
		Tree t = new Tree();
		for (int i=0; i<n; i++) {
			insert (t, (int)(Math.random()*max));
		}
		return t;
	}
	
	
	static void test1 () {
		/*
		 * 1) creiamo un albero vuoto
		 * 2) inseriamo nell'albero alcune chiavi (5 o 6)
		 * 3) richiamiamo la visita in-ordine
		 */
		Tree t = new Tree();

		insert (t, 10);
		insert (t, 1);
		insert (t, 5);
		insert (t, 4);
		insert (t, 20);
		
		inOrderWalk(t);
		
		System.out.println ("h="+height(t));
		System.out.println ("ricerca di 5="+search(t,5));
		System.out.println ("ricerca di 5="+searchIterative(t,5));
		
		System.out.println ("ricerca di 15="+search(t,15));
		System.out.println ("ricerca di 15="+searchIterative(t,15));
		
	}
	
	static void insert (Tree t, int key) {
		if (t==null) return;
		Node z = new Node();
		z.key=key;
		Node i = t.root;
		Node p = null;
		while (i!=null) {
			p=i;
			if (i.key < key) {
				i=i.right;
			} else {
				i=i.left;
			}
		}
		z.p=p;
		if (p==null) {//sto inserendo il primo nodo dell'ABR
			t.root=z;
		} else if (key <= p.key) {
			p.left=z;
		} else {
			p.right=z;
		}
	}
	
	static void inOrderWalk (Tree t) {
		if (t==null || t.root==null) return;
		
		Tree sx = new Tree();
		sx.root=(t.root).left;
		inOrderWalk (sx);
		
		System.out.println(t.root.key);
		
		Tree dx = new Tree();
		dx.root=(t.root).right;
		inOrderWalk (dx);	
	}
	
	/*
	 * scrivere un metodo ricorsivo che calcola l'altezza
	 * di un albero
	 */
	static int height (Tree t) {
		if (t==null || t.root==null) return 0;
		
		Tree sx = new Tree();
		sx.root=(t.root).left;
		int hLeft = height(sx);
		
		Tree dx = new Tree();
		dx.root=(t.root).right;
		int hRight = height(dx);
		
		if (hLeft>hRight) {
			return hLeft+1;
		} else {
			return hRight+1;
		}		
	}
	
	/*
	 * scrivere un metodo iterativo che restituisce un nodo
	 * contenente la minima chiave presente in un albero
	 */
	static Node minimum (Tree t) {
		if (t==null || t.root==null) return null;
		Node i = t.root;
		while (i.left!=null) {
			i=i.left;
		}
		return i;
	}
	
	/*
	 * scrivere un metodo ricorsivo che preso un albero t
	 * e una chiave key, restituisce null se key non è 
	 * presente in t, altrimenti restituisce un nodo di t
	 * che contiene key
	 */
	static Node search (Tree t, int key) {
		if (t==null || t.root==null) return null;
		if (t.root.key==key) return t.root;
		if (key < t.root.key) {
			Tree sx = new Tree();
			sx.root=(t.root).left;
			return search (sx, key);
		} else {
			Tree dx = new Tree();
			dx.root=(t.root).right;
			return search (dx, key);
		}
	}
	
	/*
	 * versione iterativa del metodo precedente
	 */
	static Node searchIterative (Tree t, int key) {
		if (t==null) return null;
		Node i = t.root;
		while (i!=null && i.key!=key) {
			if (key<i.key) {
				i=i.left;
			} else {
				i=i.right;
			}
		}
		return i;
	}

}
